# To ensure correct image size when batch processing, please search
# for and uncomment the line `# renderView*.ViewSize = [*,*]`

#### import the simple module from the paraview
from paraview.simple import *
#### disable automatic camera reset on 'Show'
paraview.simple._DisableFirstRenderCameraReset()

#--- Run in Terminal with: 'pvbatch PhaseDiagram_PlotScript.py'


# ----- CREATE A Phase Diagram for the following cases:
# 1. (Hyperbolic Case) Gamma = '0'
# 2. (Elliptic Case) Gamma = 'infinity'
#
# case = 1
# case = 2
#
drawLine = False




# hide_redcolor = True
hide_redcolor = False
# hide_legend = True
hide_legend = False

gamma = 'infinity'
# gamma = '0'



# phaseDiagram3DGammainfinityvts = XMLStructuredGridReader(FileName=['/home/klaus/Desktop/DUNE/dune-microstructure/outputs/PhaseDiagram3DGamma0.vts'])
# phaseDiagram3DGammainfinityvts = XMLStructuredGridReader(FileName=['/home/klaus/Desktop/DUNE/dune-microstructure/outputs/PhaseDiagram3DGammainfinity.vts'])
phaseDiagram3DGammainfinityvts = XMLStructuredGridReader(FileName=['/home/klaus/Desktop/DUNE/dune-microstructure/outputs/PhaseDiagram3DGammainfinity_shifted_150SP.vts'])
# phaseDiagram3DGammainfinityvts = XMLStructuredGridReader(FileName=['/home/klaus/Desktop/DUNE/dune-microstructure/outputs/PhaseDiagram3DGammainfinity_300P.vts'])






phaseDiagram3DGammainfinityvts.PointArrayStatus = ['Type', 'angles', 'curvature']

# get active view
renderView1 = GetActiveViewOrCreate('RenderView')
# uncomment following to set a specific view size
# renderView1.ViewSize = [999, 547]

## ---- Set a specific view size:
renderView1.ViewSize = [1257, 934]

# show data in view
phaseDiagram3DGammainfinityvtsDisplay = Show(phaseDiagram3DGammainfinityvts, renderView1)
# trace defaults for the display properties.
phaseDiagram3DGammainfinityvtsDisplay.Representation = 'Outline'
phaseDiagram3DGammainfinityvtsDisplay.ColorArrayName = ['POINTS', '']
phaseDiagram3DGammainfinityvtsDisplay.OSPRayScaleArray = 'Type'
phaseDiagram3DGammainfinityvtsDisplay.OSPRayScaleFunction = 'PiecewiseFunction'
phaseDiagram3DGammainfinityvtsDisplay.SelectOrientationVectors = 'None'
phaseDiagram3DGammainfinityvtsDisplay.ScaleFactor = 4.0
phaseDiagram3DGammainfinityvtsDisplay.SelectScaleArray = 'Type'
phaseDiagram3DGammainfinityvtsDisplay.GlyphType = 'Arrow'
phaseDiagram3DGammainfinityvtsDisplay.GlyphTableIndexArray = 'Type'
phaseDiagram3DGammainfinityvtsDisplay.GaussianRadius = 0.2
phaseDiagram3DGammainfinityvtsDisplay.SetScaleArray = ['POINTS', 'Type']
phaseDiagram3DGammainfinityvtsDisplay.ScaleTransferFunction = 'PiecewiseFunction'
phaseDiagram3DGammainfinityvtsDisplay.OpacityArray = ['POINTS', 'Type']
phaseDiagram3DGammainfinityvtsDisplay.OpacityTransferFunction = 'PiecewiseFunction'
phaseDiagram3DGammainfinityvtsDisplay.DataAxesGrid = 'GridAxesRepresentation'
phaseDiagram3DGammainfinityvtsDisplay.PolarAxes = 'PolarAxesRepresentation'
phaseDiagram3DGammainfinityvtsDisplay.ScalarOpacityUnitDistance = 1.1546332790816523

# init the 'PiecewiseFunction' selected for 'OSPRayScaleFunction'
phaseDiagram3DGammainfinityvtsDisplay.OSPRayScaleFunction.Points = [1.0, 0.8602941036224365, 0.5, 0.0, 1.213836476688135, 0.625, 0.5, 0.0, 1.3616352081298828, 0.6691176295280457, 0.5, 0.0, 1.6666333299996667, 0.8676470518112183, 0.5, 0.0, 1.7358490228652954, 0.6911764740943909, 0.5, 0.0, 2.0, 0.8014705777168274, 0.5, 0.0]

# init the 'PiecewiseFunction' selected for 'ScaleTransferFunction'
phaseDiagram3DGammainfinityvtsDisplay.ScaleTransferFunction.Points = [1.0, 0.8602941036224365, 0.5, 0.0, 1.4276729533762702, 0.625, 0.5, 0.0, 1.7232704162597656, 0.6691176295280457, 0.5, 0.0, 2.3332666599993335, 0.8676470518112183, 0.5, 0.0, 2.471698045730591, 0.6911764740943909, 0.5, 0.0, 3.0, 0.8014705777168274, 0.5, 0.0]

# init the 'PiecewiseFunction' selected for 'OpacityTransferFunction'
phaseDiagram3DGammainfinityvtsDisplay.OpacityTransferFunction.Points = [1.0, 0.8602941036224365, 0.5, 0.0, 1.4276729533762702, 0.625, 0.5, 0.0, 1.7232704162597656, 0.6691176295280457, 0.5, 0.0, 2.3332666599993335, 0.8676470518112183, 0.5, 0.0, 2.471698045730591, 0.6911764740943909, 0.5, 0.0, 3.0, 0.8014705777168274, 0.5, 0.0]

# reset view to fit data
renderView1.ResetCamera()

# update the view to ensure updated data information
renderView1.Update()

# create a new 'Transform'
transform1 = Transform(Input=phaseDiagram3DGammainfinityvts)
transform1.Transform = 'Transform'

# Properties modified on transform1.Transform
transform1.Transform.Scale = [0.05, 0.05, 1.0]

# Properties modified on transform1.Transform
# transform1.Transform.Scale = [0.025, 1.0, 1.0]

# show data in view
transform1Display = Show(transform1, renderView1)

# trace defaults for the display properties.
transform1Display.Representation = 'Outline'
transform1Display.ColorArrayName = ['POINTS', '']
transform1Display.OSPRayScaleArray = 'Type'
transform1Display.OSPRayScaleFunction = 'PiecewiseFunction'
transform1Display.SelectOrientationVectors = 'None'
transform1Display.ScaleFactor = 0.1
transform1Display.SelectScaleArray = 'Type'
transform1Display.GlyphType = 'Arrow'
transform1Display.GlyphTableIndexArray = 'Type'
transform1Display.GaussianRadius = 0.005
transform1Display.SetScaleArray = ['POINTS', 'Type']
transform1Display.ScaleTransferFunction = 'PiecewiseFunction'
transform1Display.OpacityArray = ['POINTS', 'Type']
transform1Display.OpacityTransferFunction = 'PiecewiseFunction'
transform1Display.DataAxesGrid = 'GridAxesRepresentation'
transform1Display.PolarAxes = 'PolarAxesRepresentation'
transform1Display.ScalarOpacityUnitDistance = 0.035113904022862234

# init the 'PiecewiseFunction' selected for 'OSPRayScaleFunction'
transform1Display.OSPRayScaleFunction.Points = [1.0, 0.8602941036224365, 0.5, 0.0, 1.213836476688135, 0.625, 0.5, 0.0, 1.3616352081298828, 0.6691176295280457, 0.5, 0.0, 1.6666333299996667, 0.8676470518112183, 0.5, 0.0, 1.7358490228652954, 0.6911764740943909, 0.5, 0.0, 2.0, 0.8014705777168274, 0.5, 0.0]
# init the 'PiecewiseFunction' selected for 'ScaleTransferFunction'
transform1Display.ScaleTransferFunction.Points = [1.0, 0.8602941036224365, 0.5, 0.0, 1.4276729533762702, 0.625, 0.5, 0.0, 1.7232704162597656, 0.6691176295280457, 0.5, 0.0, 2.3332666599993335, 0.8676470518112183, 0.5, 0.0, 2.471698045730591, 0.6911764740943909, 0.5, 0.0, 3.0, 0.8014705777168274, 0.5, 0.0]
# init the 'PiecewiseFunction' selected for 'OpacityTransferFunction'
transform1Display.OpacityTransferFunction.Points = [1.0, 0.8602941036224365, 0.5, 0.0, 1.4276729533762702, 0.625, 0.5, 0.0, 1.7232704162597656, 0.6691176295280457, 0.5, 0.0, 2.3332666599993335, 0.8676470518112183, 0.5, 0.0, 2.471698045730591, 0.6911764740943909, 0.5, 0.0, 3.0, 0.8014705777168274, 0.5, 0.0]

# hide data in view
Hide(phaseDiagram3DGammainfinityvts, renderView1)

# update the view to ensure updated data information
renderView1.Update()
#
# reset view to fit data
renderView1.ResetCamera()

# -------------------------------------------------------------

# toggle 3D widget visibility (only when running from the GUI)
Hide3DWidgets(proxy=transform1.Transform)

# set scalar coloring
ColorBy(transform1Display, ('POINTS', 'angles'))

# rescale color and/or opacity maps used to include current data range
transform1Display.RescaleTransferFunctionToDataRange(True, False)

# show color bar/color legend
transform1Display.SetScalarBarVisibility(renderView1, True)

# get color transfer function/color map for 'angles'
anglesLUT = GetColorTransferFunction('angles')

# get opacity transfer function/opacity map for 'angles'
anglesPWF = GetOpacityTransferFunction('angles')

# --- change representation type
transform1Display.SetRepresentationType('Point Gaussian')

# Properties modified on transform1Display
transform1Display.ShaderPreset = 'Plain circle'

# --- Properties modified on transform1Display
transform1Display.GaussianRadius = 0.0075
# Properties modified on transform1Display

##--- SET OPACITY
# transform1Display.Opacity = 0.07
transform1Display.Opacity = 0.03  #overall Opacity
# transform1Display.Opacity = 0.15  #overall Opacity

# -------------- CHANGE COLORMAP ------------------
# Apply a preset using its name. Note this may not work as expected when presets have duplicate names.

#anglesLUT.ApplyPreset('Cool to Warm', True)
anglesLUT.ApplyPreset('Jet', True)





## (Optional?) Adjust ColorMap:
# get opacity transfer function/opacity map for 'angles'
anglesPWF = GetOpacityTransferFunction('angles')    #
# get color transfer function
colorMap = GetColorTransferFunction('angles')

# get color transfer function/color map for 'angles'
anglesLUT = GetColorTransferFunction('angles')
anglesLUT.AutomaticRescaleRangeMode = "Grow and update on 'Apply'"
anglesLUT.InterpretValuesAsCategories = 0
anglesLUT.AnnotationsInitialized = 0
anglesLUT.ShowCategoricalColorsinDataRangeOnly = 0
anglesLUT.RescaleOnVisibilityChange = 0
anglesLUT.EnableOpacityMapping = 1
anglesLUT.RGBPoints = [0.0, 0.23137254902, 0.298039215686, 0.752941176471, 0.9632241725921631, 0.865, 0.865, 0.865, 1.5707963267948966, 0.705882352941, 0.0156862745098, 0.149019607843]
anglesLUT.UseLogScale = 0
anglesLUT.ColorSpace = 'Diverging'
anglesLUT.UseBelowRangeColor = 0
anglesLUT.BelowRangeColor = [0.0, 0.0, 0.0]
anglesLUT.UseAboveRangeColor = 0
anglesLUT.AboveRangeColor = [0.5, 0.5, 0.5]
anglesLUT.NanColor = [1.0, 1.0, 0.0]
anglesLUT.NanOpacity = 1.0
anglesLUT.Discretize = 1
anglesLUT.NumberOfTableValues = 256
anglesLUT.ScalarRangeInitialized = 1.0
anglesLUT.HSVWrap = 0
anglesLUT.VectorComponent = 0
anglesLUT.VectorMode = 'Magnitude'
anglesLUT.AllowDuplicateScalars = 1
anglesLUT.Annotations = []
anglesLUT.ActiveAnnotatedValues = []
anglesLUT.IndexedColors = []
anglesLUT.IndexedOpacities = []

# get opacity transfer function/opacity map for 'angles'
anglesPWF = GetOpacityTransferFunction('angles')
# anglesPWF.Points = [0.0, 0.05882352963089943, 0.5, 0.0, 0.7607001066207886, 1.0, 0.5, 0.0, 0.8693715333938599, 1.0, 0.5, 0.0, 1.0175598859786987, 1.0, 0.5, 0.0, 1.12623131275177, 1.0, 0.5, 0.0, 1.5707963267948966, 1.0, 0.5, 0.0]
anglesPWF.AllowDuplicateScalars = 1
anglesPWF.UseLogScale = 0
anglesPWF.ScalarRangeInitialized = 1

# Properties modified on anglesPWF
# anglesPWF.Points = [0.0, 0.3014705777168274, 0.5, 0.0, 0.33589355211648514, 0.625, 0.5, 0.0, 0.5680552565701278, 0.6691176295280457, 0.5, 0.0, 1.0471451860825267, 0.8676470518112183, 0.5, 0.0, 1.15586894219242, 0.6911764740943909, 0.5, 0.0, 1.5707963267948966, 0.8014705777168274, 0.5, 0.0]


# # Properties modified on anglesPWF
# anglesPWF.Points = [0.0, 0.037, 0.5, 1.0, 0.33589355211648514, 0.625, 0.5, 0.0, 0.5680552565701278, 0.6691176295280457, 0.5, 0.0, 1.0471451860825267, 0.8676470518112183, 0.5, 0.0, 1.15586894219242, 0.6911764740943909, 0.5, 0.0, 1.5707963267948966, 0.8014705777168274, 0.5, 0.0]
# Properties modified on anglesPWF
# anglesPWF.Points = [0.0, 0.036764707416296005, 0.5, 0.0, 0.7607001066207886, 1.0, 0.5, 0.0, 0.8693715333938599, 1.0, 0.5, 0.0, 1.0175598859786987, 1.0, 0.5, 0.0, 1.12623131275177, 1.0, 0.5, 0.0, 1.5707963267948966, 1.0, 0.5, 0.0]
anglesPWF.Points = [0.1, 0.136764707416296005, 0.5, 0.0, 0.7607001066207886, 1.0, 0.5, 0.0, 0.8693715333938599, 1.0, 0.5, 0.0, 1.0175598859786987, 1.0, 0.5, 0.0, 1.12623131275177, 1.0, 0.5, 0.0, 1.5707963267948966, 1.0, 0.5, 0.0]
# rescale color and/or opacity maps used to exactly fit the current data range
transform1Display.RescaleTransferFunctionToDataRange(False, True)
# # Properties modified on anglesPWF


# Properties modified on anglesLUT
anglesLUT.EnableOpacityMapping = 0
anglesLUT.EnableOpacityMapping = 1



## ---- AXES GRID PROPERTIES -----
# Properties modified on renderView1.AxesGrid
renderView1.AxesGrid.Visibility = 1

# Properties modified on renderView1.AxesGrid
renderView1.AxesGrid.XTitle = '  $\\theta_\\rho$  '
renderView1.AxesGrid.YTitle = '  $\\theta_\\mu$  '
renderView1.AxesGrid.ZTitle = '  $\\theta$   '

# renderView1.AxesGrid.XTitleFontSize = 45  #24
# renderView1.AxesGrid.YTitleFontSize = 45
# renderView1.AxesGrid.ZTitleFontSize = 45
# renderView1.AxesGrid.XLabelFontSize = 30  #default:12
# renderView1.AxesGrid.YLabelFontSize = 30
# renderView1.AxesGrid.ZLabelFontSize = 30

renderView1.AxesGrid.XTitleFontSize = 65  #24
renderView1.AxesGrid.YTitleFontSize = 65
renderView1.AxesGrid.ZTitleFontSize = 65
renderView1.AxesGrid.XLabelFontSize = 45  #default:12
renderView1.AxesGrid.YLabelFontSize = 45
renderView1.AxesGrid.ZLabelFontSize = 45

# ---- Switch of/on OrientationAXES:
# renderView1.OrientationAxesVisibility = 1
renderView1.OrientationAxesVisibility = 0
# rv = GetRenderView()
# renderView1.OrientationAxesLabelColor = [0.5, 0.5, 0.5]
# Render()

# ---- Switch Grid On/Off:
renderView1.AxesGrid.ShowGrid = 1

# # reset view to fit data
# renderView1.ResetCamera()


## Properties modified on renderView1.AxesGrid
## -- COLOR/Font-Size OF AXES-TITLE:
## -- Green:
# renderView1.AxesGrid.XTitleColor = [0.5411764705882353, 0.8862745098039215, 0.20392156862745098]
# renderView1.AxesGrid.YTitleColor = [0.5411764705882353, 0.8862745098039215, 0.20392156862745098]
# renderView1.AxesGrid.ZTitleColor = [0.5411764705882353, 0.8862745098039215, 0.20392156862745098]
## -- White:
# renderView1.AxesGrid.XTitleColor = [1.0, 1.0, 1.0]
# renderView1.AxesGrid.YTitleColor = [1.0, 1.0, 1.0]
# renderView1.AxesGrid.ZTitleColor = [1.0, 1.0, 1.0]



# Properties modified on renderView1.AxesGrid
# --- Change FontSize of Values on Axis:


# # --- Change Color of Values on Axis:
## -- Green:
# # renderView1.AxesGrid.XLabelColor = [0.5411764705882353, 0.8862745098039215, 0.20392156862745098]
# # renderView1.AxesGrid.YLabelColor = [0.5411764705882353, 0.8862745098039215, 0.20392156862745098]
# # renderView1.AxesGrid.ZLabelColor = [0.5411764705882353, 0.8862745098039215, 0.20392156862745098]
## -- White:
renderView1.AxesGrid.XLabelColor = [1.0, 1.0, 1.0]
renderView1.AxesGrid.YLabelColor = [1.0, 1.0, 1.0]
renderView1.AxesGrid.ZLabelColor = [1.0, 1.0, 1.0]

## --- Render Axes only on certain Facets:
renderView1.AxesGrid.FacesToRender = 7
renderView1.AxesGrid.ShowEdges = 0
renderView1.AxesGrid.AxesToLabel = 24


## ----------- Scale Data on Axes:
renderView1.AxesGrid.DataScale = [0.05, 0.05, 1.0]
#
# # Properties modified on renderView1.AxesGrid
## ---------- Set Custom Axis-Labels:
renderView1.AxesGrid.XAxisUseCustomLabels = 1
renderView1.AxesGrid.ZAxisUseCustomLabels = 1
renderView1.AxesGrid.YAxisUseCustomLabels = 1
renderView1.AxesGrid.XAxisLabels = [-5.0, 0.0, 5.0, 10.0, 15.0]
# renderView1.AxesGrid.YAxisLabels = [0 , 10.0, 20.0, 30.0, 40.0]
# renderView1.AxesGrid.YAxisLabels = [1 ,5, 10.0,15, 20.0,25, 30.0,35, 40.0]
renderView1.AxesGrid.YAxisLabels = [1 ,5, 10,15, 20]
# renderView1.AxesGrid.YAxisLabels = [0 ,5.0, 10.0, 15.0, 20.0, 25.0, 30.0,35.0, 40.0]
renderView1.AxesGrid.ZAxisLabels = [ 0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1.0]


## ---- SET Center-Axis visible:
renderView1.CenterAxesVisibility = 0

# ----------------- CAMERA POSITION -----------------
# current camera placement for renderView1
# renderView1.CameraPosition = [0.9924119707463583, 3.796427396663517, 1.5103327925582364]
# renderView1.CameraFocalPoint = [0.0, 0.5002500000000001, 0.5]
# renderView1.CameraViewUp = [-0.03762445763524004, -0.2824789551065148, 0.9585353619505051]
# renderView1.CameraParallelScale = 0.93323050610355
renderView1.CameraPosition = [1.320702817430001, 3.4031687433379654, 1.5124027164700495]
renderView1.CameraFocalPoint = [5.999081648913413e-18, 0.5002500000000002, 0.4999999999999999]
renderView1.CameraViewUp = [-0.09506057625109621, -0.2889757851908078, 0.9526051030811066]
renderView1.CameraParallelScale = 0.8660254037844386
renderView1.EyeAngle = 0.0

renderView1.Update()




# ----------------- LEGEND -----------------
# get color legend/bar for anglesLUT in view renderView1
anglesLUTColorBar = GetScalarBar(anglesLUT, renderView1)

# Properties modified on anglesLUTColorBar
anglesLUTColorBar.WindowLocation = 'LowerRightCorner'
anglesLUTColorBar.HorizontalTitle = 1
anglesLUTColorBar.Title = 'angle $\\alpha$'   #'angle $\\angle$'
anglesLUTColorBar.TextPosition = 'Ticks left/bottom, annotations right/top'
anglesLUTColorBar.TitleJustification = 'Left'
# anglesLUTColorBar.TitleJustification = 'Centered'

# show color bar/color legend
# transform1Display.SetScalarBarVisibility(renderView1, True)

# # # Properties modified on anglesLUTColorBar
anglesLUTColorBar.AutomaticAnnotations = 0
anglesLUTColorBar.AddRangeLabels = 0
anglesLUTColorBar.DrawTickMarks = 0
anglesLUTColorBar.DrawTickLabels = 0
anglesLUTColorBar.TitleFontSize = 24
anglesLUTColorBar.LabelFontSize = 20
# anglesLUTColorBar.AddRangeAnnotations = 1

## -- Add Annotations :
anglesLUT.Annotations = ['1.57', '$\\pi / 2$', '0.78', '$\\pi/4$', '0', '0']
anglesLUT.IndexedColors = [1.0, 1.0, 1.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0]
anglesLUT.IndexedOpacities = [1.0, 1.0, 1.0, 1.0]





















# # get color legend/bar for anglesLUT in view renderView1
# anglesLUTColorBar = GetScalarBar(anglesLUT, renderView1)

#
# if case == 1:
#     ## In Hyperbolic Case only two angles occur...
#     # Use discrete Color map:
#     # # Properties modified on anglesLUT
#     # anglesLUT.InterpretValuesAsCategories = 1
#     # anglesLUT.AnnotationsInitialized = 1
#     #
#     #
#     #
#     # # Properties modified on anglesLUT
#     # anglesLUT.Annotations = ['1.5707963267948966', '$\\pi / 2$', '0.78', '$\\pi/4$', '0', '0']
#     # # Properties modified on anglesLUT
#     # anglesLUT.IndexedColors = [1.0, 0.10196078431372549, 0.023529411764705882, 0.03137254901960784, 0.03137254901960784, 1.0]
#     # # Properties modified on anglesLUT
#     # anglesLUT.IndexedOpacities = [1.0, 0.015]
#     # # get active view
#     # renderView1 = GetActiveViewOrCreate('RenderView')
#     # # uncomment following to set a specific view size
#     # # renderView1.ViewSize = [997, 905]
#     #
#     # # get display properties
#     transform1Display = GetDisplayProperties(transform1, view=renderView1)
#     print('Hyperbolic Case (case1)')
#
#     # get color transfer function/color map for 'angles'
#     anglesLUT = GetColorTransferFunction('angles')
#     anglesLUT.AutomaticRescaleRangeMode = "Grow and update on 'Apply'"
#     anglesLUT.InterpretValuesAsCategories = 1
#     anglesLUT.AnnotationsInitialized = 1
#     anglesLUT.ShowCategoricalColorsinDataRangeOnly = 0
#     anglesLUT.RescaleOnVisibilityChange = 0
#     anglesLUT.EnableOpacityMapping = 1
#     anglesLUT.RGBPoints = [0.0, 0.23137254902, 0.298039215686, 0.752941176471, 0.9632241725921631, 0.865, 0.865, 0.865, 1.5707963267948966, 0.705882352941, 0.0156862745098, 0.149019607843]
#     anglesLUT.UseLogScale = 0
#     anglesLUT.ColorSpace = 'Diverging'
#     anglesLUT.UseBelowRangeColor = 0
#     anglesLUT.BelowRangeColor = [0.0, 0.0, 0.0]
#     anglesLUT.UseAboveRangeColor = 0
#     anglesLUT.AboveRangeColor = [0.5, 0.5, 0.5]
#     anglesLUT.NanColor = [1.0, 1.0, 0.0]
#     anglesLUT.NanOpacity = 1.0
#     anglesLUT.Discretize = 1
#     anglesLUT.NumberOfTableValues = 256
#     anglesLUT.ScalarRangeInitialized = 1.0
#     anglesLUT.HSVWrap = 0
#     anglesLUT.VectorComponent = 0
#     anglesLUT.VectorMode = 'Magnitude'
#     anglesLUT.AllowDuplicateScalars = 1
#     anglesLUT.Annotations = ['1.5707963267948966', '$\\pi / 2$', '0.78', '$\\pi/4$', '0', '0']
#     anglesLUT.ActiveAnnotatedValues = []
#     anglesLUT.IndexedColors = [1.0, 0.10196078431372549, 0.023529411764705882, 0.03137254901960784, 0.03137254901960784, 1.0]
#     anglesLUT.IndexedOpacities = [1.0, 0.015]
#
#     # Properties modified on anglesLUT
#     anglesLUT.Annotations = ['1.5707963267948966', '$\\pi / 2$', '0', '0']
#     anglesLUT.IndexedColors = [1.0, 0.10196078431372549, 0.023529411764705882, 1.0, 0.10196078431372549, 0.023529411764705882]
#     anglesLUT.IndexedOpacities = [1.0, -1.0]
#
#     # get opacity transfer function/opacity map for 'angles'
#     anglesPWF = GetOpacityTransferFunction('angles')
#     anglesPWF.Points = [0.0, 0.136764707416296, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 1.0, 0.5, 0.0]
#     anglesPWF.AllowDuplicateScalars = 1
#     anglesPWF.UseLogScale = 0
#     anglesPWF.ScalarRangeInitialized = 1
#
#     # Properties modified on anglesLUT
#     anglesLUT.IndexedColors = [1.0, 0.10196078431372549, 0.023529411764705882, 0.07450980392156863, 0.043137254901960784, 1.0]
#
#     # Properties modified on anglesLUT
#     anglesLUT.IndexedOpacities = [1.0, 0.01]
#
#     # get active source.
#     transform1 = GetActiveSource()
#
#     # get active view
#     renderView1 = GetActiveViewOrCreate('RenderView')
#     # uncomment following to set a specific view size
#     # renderView1.ViewSize = [1257, 934]
#
#     # get display properties
#     transform1Display = GetDisplayProperties(transform1, view=renderView1)
#
#     # Properties modified on transform1Display
#     transform1Display.Opacity = 0.2
#
#     transform1Display.GaussianRadius = 0.02
#
#     # Properties modified on anglesLUT
#     anglesLUT.IndexedOpacities = [1.0, 0.017]
# elseif case == 2:
#





# Properties modified on anglesLUT
anglesLUT.RGBPoints = [0.0, 0.23137254902, 0.298039215686, 0.752941176471, 0.9632241725921631, 0.865, 0.865, 0.865, 1.5707963267948966, 1.0, 0.0, 0.0]

# get opacity transfer function/opacity map for 'angles'
anglesPWF = GetOpacityTransferFunction('angles')
anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 0.11764705926179886, 0.5, 0.0]
anglesPWF.ScalarRangeInitialized = 1

# # Apply a preset using its name. Note this may not work as expected when presets have duplicate names.
# anglesLUT.ApplyPreset('jet', True)
#
# # Apply a preset using its name. Note this may not work as expected when presets have duplicate names.
# anglesLUT.ApplyPreset('jet', True)
#
# # Apply a preset using its name. Note this may not work as expected when presets have duplicate names.
# anglesLUT.ApplyPreset('jet', True)
#
# # Apply a preset using its name. Note this may not work as expected when presets have duplicate names.
# anglesLUT.ApplyPreset('jet', True)

# Properties modified on anglesLUT
anglesLUT.RGBPoints = [0.0, 0.0, 0.0, 0.5625, 0.17453275066650778, 0.0, 0.0, 1.0, 0.5734655375881175, 0.0, 1.0, 1.0, 0.7729315383498405, 0.5, 1.0, 0.5, 0.9723975391115637, 1.0, 1.0, 0.0, 1.3713303260331735, 1.0, 0.0, 0.0, 1.5707963267948966, 0.6588235294117647, 0.0, 0.0]

# Properties modified on anglesPWF
anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 0.15441176295280457, 0.5, 0.0]

# Properties modified on anglesPWF
anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 0.11764705926179886, 0.5, 0.0]

# Properties modified on anglesPWF
anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 0.10294117778539658, 0.5, 0.0]

# Properties modified on anglesPWF
anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 0.07352941483259201, 0.5, 0.0]

# Properties modified on anglesPWF
anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 0.08088235557079315, 0.5, 0.0]

# Properties modified on anglesPWF
anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 0.0882352963089943, 0.5, 0.0]

# Properties modified on anglesPWF
anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 0.09558823704719543, 0.5, 0.0]

# Properties modified on anglesPWF
anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 0.10294117778539658, 0.5, 0.0]

# Properties modified on anglesPWF
anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 0.11029411852359772, 0.5, 0.0]

# Properties modified on anglesPWF
anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 0.09558823704719543, 0.5, 0.0]

# Properties modified on anglesPWF
anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 0.13235294818878174, 0.5, 0.0]



###-- ALTERNATIVE WARM TO COOL :
# Apply a preset using its name. Note this may not work as expected when presets have duplicate names.
anglesLUT.ApplyPreset('Warm to Cool (Extended)', True)

# get opacity transfer function/opacity map for 'angles'
anglesPWF = GetOpacityTransferFunction('angles')
anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 0.13235294818878174, 0.5, 0.0]
anglesPWF.ScalarRangeInitialized = 1


# Apply a preset using its name. Note this may not work as expected when presets have duplicate names.
anglesLUT.ApplyPreset('Warm to Cool (Extended)', True)

#TEST
# anglesLUT.ApplyPreset('jet', True)

# invert the transfer function
anglesLUT.InvertTransferFunction()

# Properties modified on anglesLUT
anglesLUT.RGBPoints = [0.0, 0.12549, 0.0, 0.380392, 0.03926990816987245, 0.113725, 0.0235294, 0.45098, 0.0785398163397449, 0.105882, 0.0509804, 0.509804, 0.11780972450961717, 0.0392157, 0.0392157, 0.560784, 0.15707963267948963, 0.0313725, 0.0980392, 0.6, 0.19634954084936207, 0.0431373, 0.164706, 0.639216, 0.2356194490192345, 0.054902, 0.243137, 0.678431, 0.27488935718910695, 0.054902, 0.317647, 0.709804, 0.31415926535897926, 0.0509804, 0.396078, 0.741176, 0.35342917352885167, 0.0392157, 0.466667, 0.768627, 0.39269908169872414, 0.0313725, 0.537255, 0.788235, 0.450920647551377, 0.0313725, 0.615686, 0.811765, 0.5001541168221094, 0.0235294, 0.709804, 0.831373, 0.5470439579732639, 0.0509804, 0.8, 0.85098, 0.581428689566804, 0.0705882, 0.854902, 0.870588, 0.618940876646993, 0.262745, 0.901961, 0.862745, 0.6478560954306335, 0.423529, 0.941176, 0.87451, 0.6845860259400787, 0.572549, 0.964706, 0.835294, 0.7119383023785582, 0.658824, 0.980392, 0.843137, 0.7361646941267158, 0.764706, 0.980392, 0.866667, 0.7596088293041297, 0.827451, 0.980392, 0.886275, 0.7838273670706534, 0.913725, 0.988235, 0.937255, 0.7853981633974483, 1.0, 1.0, 1.0, 0.7869689597242432, 0.988235, 0.980392, 0.870588, 0.8111874974907669, 0.992157, 0.964706, 0.713725, 0.8322880045486029, 0.988235, 0.956863, 0.643137, 0.8729260763191136, 0.980392, 0.917647, 0.509804, 0.9127818915188803, 0.968627, 0.87451, 0.407843, 0.9495118220283256, 0.94902, 0.823529, 0.321569, 0.9817477042468103, 0.929412, 0.776471, 0.278431, 1.0210176124166828, 0.909804, 0.717647, 0.235294, 1.0602875205865552, 0.890196, 0.658824, 0.196078, 1.0995574287564276, 0.878431, 0.619608, 0.168627, 1.1388273369263, 0.870588, 0.54902, 0.156863, 1.1780972450961724, 0.85098, 0.47451, 0.145098, 1.2173671532660448, 0.831373, 0.411765, 0.133333, 1.2566370614359172, 0.811765, 0.345098, 0.113725, 1.2959069696057897, 0.788235, 0.266667, 0.0941176, 1.335176877775662, 0.741176, 0.184314, 0.0745098, 1.3744467859455345, 0.690196, 0.12549, 0.0627451, 1.413716694115407, 0.619608, 0.0627451, 0.0431373, 1.4922565104551517, 0.470588, 0.0156863, 0.0901961, 1.5315264186250241, 0.4, 0.00392157, 0.101961, 1.5707963267948966, 0.34902, 0.0, 0.129412]

# Properties modified on anglesLUT
anglesLUT.RGBPoints = [0.0, 0.12549, 0.0, 0.380392, 0.03926990816987245, 0.113725, 0.0235294, 0.45098, 0.0785398163397449, 0.105882, 0.0509804, 0.509804, 0.11780972450961717, 0.0392157, 0.0392157, 0.560784, 0.15707963267948963, 0.0313725, 0.0980392, 0.6, 0.19634954084936207, 0.0431373, 0.164706, 0.639216, 0.2356194490192345, 0.054902, 0.243137, 0.678431, 0.27488935718910695, 0.054902, 0.317647, 0.709804, 0.31415926535897926, 0.0509804, 0.396078, 0.741176, 0.35342917352885167, 0.0392157, 0.466667, 0.768627, 0.39269908169872414, 0.0313725, 0.537255, 0.788235, 0.450920647551377, 0.0313725, 0.615686, 0.811765, 0.5001541168221094, 0.0235294, 0.709804, 0.831373, 0.5470439579732639, 0.0509804, 0.8, 0.85098, 0.581428689566804, 0.0705882, 0.854902, 0.870588, 0.618940876646993, 0.262745, 0.901961, 0.862745, 0.6478560954306335, 0.423529, 0.941176, 0.87451, 0.6845860259400787, 0.572549, 0.964706, 0.835294, 0.7119383023785582, 0.658824, 0.980392, 0.843137, 0.7361646941267158, 0.764706, 0.980392, 0.866667, 0.7596088293041297, 0.827451, 0.980392, 0.886275, 0.7838273670706534, 0.913725, 0.988235, 0.937255, 0.7853981633974483, 1.0, 1.0, 1.0, 0.7869689597242432, 0.988235, 0.980392, 0.870588, 0.8111874974907669, 0.992157, 0.964706, 0.713725, 0.8322880045486029, 0.988235, 0.956863, 0.643137, 0.8729260763191136, 0.980392, 0.917647, 0.509804, 0.9127818915188803, 0.968627, 0.87451, 0.407843, 0.9495118220283256, 0.94902, 0.823529, 0.321569, 0.9817477042468103, 0.929412, 0.776471, 0.278431, 1.0210176124166828, 0.909804, 0.717647, 0.235294, 1.0602875205865552, 0.890196, 0.658824, 0.196078, 1.0995574287564276, 0.878431, 0.619608, 0.168627, 1.1388273369263, 0.870588, 0.54902, 0.156863, 1.1780972450961724, 0.85098, 0.47451, 0.145098, 1.2173671532660448, 0.831373, 0.411765, 0.133333, 1.2566370614359172, 0.811765, 0.345098, 0.113725, 1.2959069696057897, 0.788235, 0.266667, 0.0941176, 1.335176877775662, 0.741176, 0.184314, 0.0745098, 1.3744467859455345, 0.690196, 0.12549, 0.0627451, 1.413716694115407, 0.619608, 0.0627451, 0.0431373, 1.5315264186250241, 0.4, 0.00392157, 0.101961, 1.5707963267948966, 0.34902, 0.0, 0.129412]

# Properties modified on anglesLUT
anglesLUT.RGBPoints = [0.0, 0.12549, 0.0, 0.380392, 0.03926990816987245, 0.113725, 0.0235294, 0.45098, 0.0785398163397449, 0.105882, 0.0509804, 0.509804, 0.11780972450961717, 0.0392157, 0.0392157, 0.560784, 0.15707963267948963, 0.0313725, 0.0980392, 0.6, 0.19634954084936207, 0.0431373, 0.164706, 0.639216, 0.2356194490192345, 0.054902, 0.243137, 0.678431, 0.27488935718910695, 0.054902, 0.317647, 0.709804, 0.31415926535897926, 0.0509804, 0.396078, 0.741176, 0.35342917352885167, 0.0392157, 0.466667, 0.768627, 0.39269908169872414, 0.0313725, 0.537255, 0.788235, 0.450920647551377, 0.0313725, 0.615686, 0.811765, 0.5001541168221094, 0.0235294, 0.709804, 0.831373, 0.5470439579732639, 0.0509804, 0.8, 0.85098, 0.581428689566804, 0.0705882, 0.854902, 0.870588, 0.618940876646993, 0.262745, 0.901961, 0.862745, 0.6478560954306335, 0.423529, 0.941176, 0.87451, 0.6845860259400787, 0.572549, 0.964706, 0.835294, 0.7119383023785582, 0.658824, 0.980392, 0.843137, 0.7361646941267158, 0.764706, 0.980392, 0.866667, 0.7596088293041297, 0.827451, 0.980392, 0.886275, 0.7838273670706534, 0.913725, 0.988235, 0.937255, 0.7853981633974483, 1.0, 1.0, 1.0, 0.7869689597242432, 0.988235, 0.980392, 0.870588, 0.8111874974907669, 0.992157, 0.964706, 0.713725, 0.8322880045486029, 0.988235, 0.956863, 0.643137, 0.8729260763191136, 0.980392, 0.917647, 0.509804, 0.9127818915188803, 0.968627, 0.87451, 0.407843, 0.9495118220283256, 0.94902, 0.823529, 0.321569, 0.9817477042468103, 0.929412, 0.776471, 0.278431, 1.0210176124166828, 0.909804, 0.717647, 0.235294, 1.0602875205865552, 0.890196, 0.658824, 0.196078, 1.0995574287564276, 0.878431, 0.619608, 0.168627, 1.1388273369263, 0.870588, 0.54902, 0.156863, 1.1780972450961724, 0.85098, 0.47451, 0.145098, 1.2173671532660448, 0.831373, 0.411765, 0.133333, 1.2566370614359172, 0.811765, 0.345098, 0.113725, 1.2959069696057897, 0.788235, 0.266667, 0.0941176, 1.335176877775662, 0.741176, 0.184314, 0.0745098, 1.3744467859455345, 0.690196, 0.12549, 0.0627451, 1.413716694115407, 0.619608, 0.0627451, 0.0431373, 1.531279444694519, 0.396078431372549, 0.00392156862745098, 0.10196078431372549, 1.5315264186250241, 0.4, 0.00392157, 0.101961, 1.5707963267948966, 0.34902, 0.0, 0.129412]

# Properties modified on anglesLUT
anglesLUT.RGBPoints = [0.0, 0.12549, 0.0, 0.380392, 0.03926990816987245, 0.113725, 0.0235294, 0.45098, 0.0785398163397449, 0.105882, 0.0509804, 0.509804, 0.11780972450961717, 0.0392157, 0.0392157, 0.560784, 0.15707963267948963, 0.0313725, 0.0980392, 0.6, 0.19634954084936207, 0.0431373, 0.164706, 0.639216, 0.2356194490192345, 0.054902, 0.243137, 0.678431, 0.27488935718910695, 0.054902, 0.317647, 0.709804, 0.31415926535897926, 0.0509804, 0.396078, 0.741176, 0.35342917352885167, 0.0392157, 0.466667, 0.768627, 0.39269908169872414, 0.0313725, 0.537255, 0.788235, 0.450920647551377, 0.0313725, 0.615686, 0.811765, 0.5001541168221094, 0.0235294, 0.709804, 0.831373, 0.5470439579732639, 0.0509804, 0.8, 0.85098, 0.581428689566804, 0.0705882, 0.854902, 0.870588, 0.618940876646993, 0.262745, 0.901961, 0.862745, 0.6478560954306335, 0.423529, 0.941176, 0.87451, 0.6845860259400787, 0.572549, 0.964706, 0.835294, 0.7119383023785582, 0.658824, 0.980392, 0.843137, 0.7361646941267158, 0.764706, 0.980392, 0.866667, 0.7596088293041297, 0.827451, 0.980392, 0.886275, 0.7838273670706534, 0.913725, 0.988235, 0.937255, 0.7853981633974483, 1.0, 1.0, 1.0, 0.7869689597242432, 0.988235, 0.980392, 0.870588, 0.8111874974907669, 0.992157, 0.964706, 0.713725, 0.8322880045486029, 0.988235, 0.956863, 0.643137, 0.8729260763191136, 0.980392, 0.917647, 0.509804, 0.9127818915188803, 0.968627, 0.87451, 0.407843, 0.9495118220283256, 0.94902, 0.823529, 0.321569, 0.9817477042468103, 0.929412, 0.776471, 0.278431, 1.0210176124166828, 0.909804, 0.717647, 0.235294, 1.0602875205865552, 0.890196, 0.658824, 0.196078, 1.0995574287564276, 0.878431, 0.619608, 0.168627, 1.1388273369263, 0.870588, 0.54902, 0.156863, 1.1780972450961724, 0.85098, 0.47451, 0.145098, 1.2173671532660448, 0.831373, 0.411765, 0.133333, 1.2566370614359172, 0.811765, 0.345098, 0.113725, 1.2959069696057897, 0.788235, 0.266667, 0.0941176, 1.335176877775662, 0.741176, 0.184314, 0.0745098, 1.3744467859455345, 0.690196, 0.12549, 0.0627451, 1.413716694115407, 0.619608, 0.0627451, 0.0431373, 1.5016417503356934, 0.396078431372549, 0.00392156862745098, 0.10196078431372549, 1.5315264186250241, 0.4, 0.00392157, 0.101961, 1.5707963267948966, 0.34902, 0.0, 0.129412]

# Properties modified on anglesLUT
anglesLUT.RGBPoints = [0.0, 0.12549, 0.0, 0.380392, 0.03926990816987245, 0.113725, 0.0235294, 0.45098, 0.0785398163397449, 0.105882, 0.0509804, 0.509804, 0.11780972450961717, 0.0392157, 0.0392157, 0.560784, 0.15707963267948963, 0.0313725, 0.0980392, 0.6, 0.19634954084936207, 0.0431373, 0.164706, 0.639216, 0.2356194490192345, 0.054902, 0.243137, 0.678431, 0.27488935718910695, 0.054902, 0.317647, 0.709804, 0.31415926535897926, 0.0509804, 0.396078, 0.741176, 0.35342917352885167, 0.0392157, 0.466667, 0.768627, 0.39269908169872414, 0.0313725, 0.537255, 0.788235, 0.450920647551377, 0.0313725, 0.615686, 0.811765, 0.5001541168221094, 0.0235294, 0.709804, 0.831373, 0.5470439579732639, 0.0509804, 0.8, 0.85098, 0.581428689566804, 0.0705882, 0.854902, 0.870588, 0.618940876646993, 0.262745, 0.901961, 0.862745, 0.6478560954306335, 0.423529, 0.941176, 0.87451, 0.6845860259400787, 0.572549, 0.964706, 0.835294, 0.7119383023785582, 0.658824, 0.980392, 0.843137, 0.7361646941267158, 0.764706, 0.980392, 0.866667, 0.7596088293041297, 0.827451, 0.980392, 0.886275, 0.7838273670706534, 0.913725, 0.988235, 0.937255, 0.7853981633974483, 1.0, 1.0, 1.0, 0.7869689597242432, 0.988235, 0.980392, 0.870588, 0.8111874974907669, 0.992157, 0.964706, 0.713725, 0.8322880045486029, 0.988235, 0.956863, 0.643137, 0.8729260763191136, 0.980392, 0.917647, 0.509804, 0.9127818915188803, 0.968627, 0.87451, 0.407843, 0.9495118220283256, 0.94902, 0.823529, 0.321569, 0.9817477042468103, 0.929412, 0.776471, 0.278431, 1.0210176124166828, 0.909804, 0.717647, 0.235294, 1.0602875205865552, 0.890196, 0.658824, 0.196078, 1.0995574287564276, 0.878431, 0.619608, 0.168627, 1.1388273369263, 0.870588, 0.54902, 0.156863, 1.1780972450961724, 0.85098, 0.47451, 0.145098, 1.2173671532660448, 0.831373, 0.411765, 0.133333, 1.2566370614359172, 0.811765, 0.345098, 0.113725, 1.2959069696057897, 0.788235, 0.266667, 0.0941176, 1.335176877775662, 0.741176, 0.184314, 0.0745098, 1.3744467859455345, 0.690196, 0.12549, 0.0627451, 1.413716694115407, 0.619608, 0.0627451, 0.0431373, 1.5016417503356934, 0.396078431372549, 0.00392156862745098, 0.10196078431372549, 1.5315264186250241, 0.4, 0.00392157, 0.101961, 1.5707963267948966, 0.6352941176470588, 0.00392156862745098, 0.01568627450980392]

# Properties modified on anglesLUT
anglesLUT.RGBPoints = [0.0, 0.12549, 0.0, 0.380392, 0.03926990816987245, 0.113725, 0.0235294, 0.45098, 0.0785398163397449, 0.105882, 0.0509804, 0.509804, 0.11780972450961717, 0.0392157, 0.0392157, 0.560784, 0.15707963267948963, 0.0313725, 0.0980392, 0.6, 0.19634954084936207, 0.0431373, 0.164706, 0.639216, 0.2356194490192345, 0.054902, 0.243137, 0.678431, 0.27488935718910695, 0.054902, 0.317647, 0.709804, 0.31415926535897926, 0.0509804, 0.396078, 0.741176, 0.35342917352885167, 0.0392157, 0.466667, 0.768627, 0.39269908169872414, 0.0313725, 0.537255, 0.788235, 0.450920647551377, 0.0313725, 0.615686, 0.811765, 0.5001541168221094, 0.0235294, 0.709804, 0.831373, 0.5470439579732639, 0.0509804, 0.8, 0.85098, 0.581428689566804, 0.0705882, 0.854902, 0.870588, 0.618940876646993, 0.262745, 0.901961, 0.862745, 0.6478560954306335, 0.423529, 0.941176, 0.87451, 0.6845860259400787, 0.572549, 0.964706, 0.835294, 0.7119383023785582, 0.658824, 0.980392, 0.843137, 0.7361646941267158, 0.764706, 0.980392, 0.866667, 0.7596088293041297, 0.827451, 0.980392, 0.886275, 0.7838273670706534, 0.913725, 0.988235, 0.937255, 0.7853981633974483, 1.0, 1.0, 1.0, 0.7869689597242432, 0.988235, 0.980392, 0.870588, 0.8111874974907669, 0.992157, 0.964706, 0.713725, 0.8322880045486029, 0.988235, 0.956863, 0.643137, 0.8729260763191136, 0.980392, 0.917647, 0.509804, 0.9127818915188803, 0.968627, 0.87451, 0.407843, 0.9495118220283256, 0.94902, 0.823529, 0.321569, 0.9817477042468103, 0.929412, 0.776471, 0.278431, 1.0210176124166828, 0.909804, 0.717647, 0.235294, 1.0602875205865552, 0.890196, 0.658824, 0.196078, 1.0995574287564276, 0.878431, 0.619608, 0.168627, 1.1388273369263, 0.870588, 0.54902, 0.156863, 1.1780972450961724, 0.85098, 0.47451, 0.145098, 1.2173671532660448, 0.831373, 0.411765, 0.133333, 1.2566370614359172, 0.811765, 0.345098, 0.113725, 1.2959069696057897, 0.788235, 0.266667, 0.0941176, 1.335176877775662, 0.741176, 0.184314, 0.0745098, 1.3744467859455345, 0.690196, 0.12549, 0.0627451, 1.413716694115407, 0.619608, 0.0627451, 0.0431373, 1.5315264186250241, 0.4, 0.00392157, 0.101961, 1.5707963267948966, 0.6352941176470588, 0.00392156862745098, 0.01568627450980392]

# Properties modified on anglesLUT
anglesLUT.RGBPoints = [0.0, 0.12549, 0.0, 0.380392, 0.03926990816987245, 0.113725, 0.0235294, 0.45098, 0.0785398163397449, 0.105882, 0.0509804, 0.509804, 0.11780972450961717, 0.0392157, 0.0392157, 0.560784, 0.15707963267948963, 0.0313725, 0.0980392, 0.6, 0.19634954084936207, 0.0431373, 0.164706, 0.639216, 0.2356194490192345, 0.054902, 0.243137, 0.678431, 0.27488935718910695, 0.054902, 0.317647, 0.709804, 0.31415926535897926, 0.0509804, 0.396078, 0.741176, 0.35342917352885167, 0.0392157, 0.466667, 0.768627, 0.39269908169872414, 0.0313725, 0.537255, 0.788235, 0.450920647551377, 0.0313725, 0.615686, 0.811765, 0.5001541168221094, 0.0235294, 0.709804, 0.831373, 0.5470439579732639, 0.0509804, 0.8, 0.85098, 0.581428689566804, 0.0705882, 0.854902, 0.870588, 0.618940876646993, 0.262745, 0.901961, 0.862745, 0.6478560954306335, 0.423529, 0.941176, 0.87451, 0.6845860259400787, 0.572549, 0.964706, 0.835294, 0.7119383023785582, 0.658824, 0.980392, 0.843137, 0.7361646941267158, 0.764706, 0.980392, 0.866667, 0.7596088293041297, 0.827451, 0.980392, 0.886275, 0.7838273670706534, 0.913725, 0.988235, 0.937255, 0.7853981633974483, 1.0, 1.0, 1.0, 0.7869689597242432, 0.988235, 0.980392, 0.870588, 0.8111874974907669, 0.992157, 0.964706, 0.713725, 0.8322880045486029, 0.988235, 0.956863, 0.643137, 0.8729260763191136, 0.980392, 0.917647, 0.509804, 0.9127818915188803, 0.968627, 0.87451, 0.407843, 0.9495118220283256, 0.94902, 0.823529, 0.321569, 0.9817477042468103, 0.929412, 0.776471, 0.278431, 1.0210176124166828, 0.909804, 0.717647, 0.235294, 1.0602875205865552, 0.890196, 0.658824, 0.196078, 1.0995574287564276, 0.878431, 0.619608, 0.168627, 1.1388273369263, 0.870588, 0.54902, 0.156863, 1.1780972450961724, 0.85098, 0.47451, 0.145098, 1.2173671532660448, 0.831373, 0.411765, 0.133333, 1.2566370614359172, 0.811765, 0.345098, 0.113725, 1.2959069696057897, 0.788235, 0.266667, 0.0941176, 1.335176877775662, 0.741176, 0.184314, 0.0745098, 1.3744467859455345, 0.690196, 0.12549, 0.0627451, 1.413716694115407, 0.619608, 0.0627451, 0.0431373, 1.5115209817886353, 0.4, 0.00392157, 0.101961, 1.5707963267948966, 0.6352941176470588, 0.00392156862745098, 0.01568627450980392]

# Properties modified on anglesLUT
anglesLUT.RGBPoints = [0.0, 0.12549, 0.0, 0.380392, 0.03926990816987245, 0.113725, 0.0235294, 0.45098, 0.0785398163397449, 0.105882, 0.0509804, 0.509804, 0.11780972450961717, 0.0392157, 0.0392157, 0.560784, 0.15707963267948963, 0.0313725, 0.0980392, 0.6, 0.19634954084936207, 0.0431373, 0.164706, 0.639216, 0.2356194490192345, 0.054902, 0.243137, 0.678431, 0.27488935718910695, 0.054902, 0.317647, 0.709804, 0.31415926535897926, 0.0509804, 0.396078, 0.741176, 0.35342917352885167, 0.0392157, 0.466667, 0.768627, 0.39269908169872414, 0.0313725, 0.537255, 0.788235, 0.450920647551377, 0.0313725, 0.615686, 0.811765, 0.5001541168221094, 0.0235294, 0.709804, 0.831373, 0.5470439579732639, 0.0509804, 0.8, 0.85098, 0.581428689566804, 0.0705882, 0.854902, 0.870588, 0.618940876646993, 0.262745, 0.901961, 0.862745, 0.6478560954306335, 0.423529, 0.941176, 0.87451, 0.6845860259400787, 0.572549, 0.964706, 0.835294, 0.7119383023785582, 0.658824, 0.980392, 0.843137, 0.7361646941267158, 0.764706, 0.980392, 0.866667, 0.7596088293041297, 0.827451, 0.980392, 0.886275, 0.7838273670706534, 0.913725, 0.988235, 0.937255, 0.7853981633974483, 1.0, 1.0, 1.0, 0.7869689597242432, 0.988235, 0.980392, 0.870588, 0.8111874974907669, 0.992157, 0.964706, 0.713725, 0.8322880045486029, 0.988235, 0.956863, 0.643137, 0.8729260763191136, 0.980392, 0.917647, 0.509804, 0.9127818915188803, 0.968627, 0.87451, 0.407843, 0.9495118220283256, 0.94902, 0.823529, 0.321569, 0.9817477042468103, 0.929412, 0.776471, 0.278431, 1.0210176124166828, 0.909804, 0.717647, 0.235294, 1.0602875205865552, 0.890196, 0.658824, 0.196078, 1.0995574287564276, 0.878431, 0.619608, 0.168627, 1.1388273369263, 0.870588, 0.54902, 0.156863, 1.1780972450961724, 0.85098, 0.47451, 0.145098, 1.2173671532660448, 0.831373, 0.411765, 0.133333, 1.2566370614359172, 0.811765, 0.345098, 0.113725, 1.2959069696057897, 0.788235, 0.266667, 0.0941176, 1.335176877775662, 0.741176, 0.184314, 0.0745098, 1.3744467859455345, 0.690196, 0.12549, 0.0627451, 1.413716694115407, 0.619608, 0.0627451, 0.0431373, 1.4571852684020996, 0.4, 0.00392157, 0.101961, 1.5707963267948966, 0.6352941176470588, 0.00392156862745098, 0.01568627450980392]

# Properties modified on anglesLUT
anglesLUT.RGBPoints = [0.0, 0.12549, 0.0, 0.380392, 0.03926990816987245, 0.113725, 0.0235294, 0.45098, 0.0785398163397449, 0.105882, 0.0509804, 0.509804, 0.11780972450961717, 0.0392157, 0.0392157, 0.560784, 0.15707963267948963, 0.0313725, 0.0980392, 0.6, 0.19634954084936207, 0.0431373, 0.164706, 0.639216, 0.2356194490192345, 0.054902, 0.243137, 0.678431, 0.27488935718910695, 0.054902, 0.317647, 0.709804, 0.31415926535897926, 0.0509804, 0.396078, 0.741176, 0.35342917352885167, 0.0392157, 0.466667, 0.768627, 0.39269908169872414, 0.0313725, 0.537255, 0.788235, 0.450920647551377, 0.0313725, 0.615686, 0.811765, 0.5001541168221094, 0.0235294, 0.709804, 0.831373, 0.5470439579732639, 0.0509804, 0.8, 0.85098, 0.581428689566804, 0.0705882, 0.854902, 0.870588, 0.618940876646993, 0.262745, 0.901961, 0.862745, 0.6478560954306335, 0.423529, 0.941176, 0.87451, 0.6845860259400787, 0.572549, 0.964706, 0.835294, 0.7119383023785582, 0.658824, 0.980392, 0.843137, 0.7361646941267158, 0.764706, 0.980392, 0.866667, 0.7596088293041297, 0.827451, 0.980392, 0.886275, 0.7838273670706534, 0.913725, 0.988235, 0.937255, 0.7853981633974483, 1.0, 1.0, 1.0, 0.7869689597242432, 0.988235, 0.980392, 0.870588, 0.8111874974907669, 0.992157, 0.964706, 0.713725, 0.8322880045486029, 0.988235, 0.956863, 0.643137, 0.8729260763191136, 0.980392, 0.917647, 0.509804, 0.9127818915188803, 0.968627, 0.87451, 0.407843, 0.9495118220283256, 0.94902, 0.823529, 0.321569, 0.9817477042468103, 0.929412, 0.776471, 0.278431, 1.0210176124166828, 0.909804, 0.717647, 0.235294, 1.0602875205865552, 0.890196, 0.658824, 0.196078, 1.0995574287564276, 0.878431, 0.619608, 0.168627, 1.1388273369263, 0.870588, 0.54902, 0.156863, 1.1780972450961724, 0.85098, 0.47451, 0.145098, 1.2173671532660448, 0.831373, 0.411765, 0.133333, 1.2566370614359172, 0.811765, 0.345098, 0.113725, 1.2959069696057897, 0.788235, 0.266667, 0.0941176, 1.335176877775662, 0.741176, 0.184314, 0.0745098, 1.3744467859455345, 0.690196, 0.12549, 0.0627451, 1.413716694115407, 0.619608, 0.0627451, 0.0431373, 1.4571852684020996, 0.4, 0.00392157, 0.101961, 1.5707963267948966, 0.8117647058823529, 0.0, 0.027450980392156862]

# Properties modified on anglesLUT
anglesLUT.RGBPoints = [0.0, 0.12549, 0.0, 0.380392, 0.03926990816987245, 0.113725, 0.0235294, 0.45098, 0.0785398163397449, 0.105882, 0.0509804, 0.509804, 0.11780972450961717, 0.0392157, 0.0392157, 0.560784, 0.15707963267948963, 0.0313725, 0.0980392, 0.6, 0.19634954084936207, 0.0431373, 0.164706, 0.639216, 0.2356194490192345, 0.054902, 0.243137, 0.678431, 0.27488935718910695, 0.054902, 0.317647, 0.709804, 0.31415926535897926, 0.0509804, 0.396078, 0.741176, 0.35342917352885167, 0.0392157, 0.466667, 0.768627, 0.39269908169872414, 0.0313725, 0.537255, 0.788235, 0.450920647551377, 0.0313725, 0.615686, 0.811765, 0.5001541168221094, 0.0235294, 0.709804, 0.831373, 0.5470439579732639, 0.0509804, 0.8, 0.85098, 0.581428689566804, 0.0705882, 0.854902, 0.870588, 0.618940876646993, 0.262745, 0.901961, 0.862745, 0.6478560954306335, 0.423529, 0.941176, 0.87451, 0.6845860259400787, 0.572549, 0.964706, 0.835294, 0.7119383023785582, 0.658824, 0.980392, 0.843137, 0.7361646941267158, 0.764706, 0.980392, 0.866667, 0.7596088293041297, 0.827451, 0.980392, 0.886275, 0.7838273670706534, 0.913725, 0.988235, 0.937255, 0.7853981633974483, 1.0, 1.0, 1.0, 0.7869689597242432, 0.988235, 0.980392, 0.870588, 0.8111874974907669, 0.992157, 0.964706, 0.713725, 0.8322880045486029, 0.988235, 0.956863, 0.643137, 0.8729260763191136, 0.980392, 0.917647, 0.509804, 0.9127818915188803, 0.968627, 0.87451, 0.407843, 0.9495118220283256, 0.94902, 0.823529, 0.321569, 0.9817477042468103, 0.929412, 0.776471, 0.278431, 1.0210176124166828, 0.909804, 0.717647, 0.235294, 1.0602875205865552, 0.890196, 0.658824, 0.196078, 1.0995574287564276, 0.878431, 0.619608, 0.168627, 1.1388273369263, 0.870588, 0.54902, 0.156863, 1.1780972450961724, 0.85098, 0.47451, 0.145098, 1.2173671532660448, 0.831373, 0.411765, 0.133333, 1.2566370614359172, 0.811765, 0.345098, 0.113725, 1.2959069696057897, 0.788235, 0.266667, 0.0941176, 1.335176877775662, 0.741176, 0.184314, 0.0745098, 1.3744467859455345, 0.690196, 0.12549, 0.0627451, 1.413716694115407, 0.619608, 0.0627451, 0.0431373, 1.4571852684020996, 0.4, 0.00392157, 0.101961, 1.5707963267948966, 0.7490196078431373, 0.0, 0.03529411764705882]

# Properties modified on anglesLUT
anglesLUT.RGBPoints = [0.0, 0.12549, 0.0, 0.380392, 0.03926990816987245, 0.113725, 0.0235294, 0.45098, 0.0785398163397449, 0.105882, 0.0509804, 0.509804, 0.11780972450961717, 0.0392157, 0.0392157, 0.560784, 0.15707963267948963, 0.0313725, 0.0980392, 0.6, 0.19634954084936207, 0.0431373, 0.164706, 0.639216, 0.2356194490192345, 0.054902, 0.243137, 0.678431, 0.27488935718910695, 0.054902, 0.317647, 0.709804, 0.31415926535897926, 0.0509804, 0.396078, 0.741176, 0.35342917352885167, 0.0392157, 0.466667, 0.768627, 0.39269908169872414, 0.0313725, 0.537255, 0.788235, 0.450920647551377, 0.0313725, 0.615686, 0.811765, 0.5001541168221094, 0.0235294, 0.709804, 0.831373, 0.5470439579732639, 0.0509804, 0.8, 0.85098, 0.581428689566804, 0.0705882, 0.854902, 0.870588, 0.618940876646993, 0.262745, 0.901961, 0.862745, 0.6478560954306335, 0.423529, 0.941176, 0.87451, 0.6845860259400787, 0.572549, 0.964706, 0.835294, 0.7119383023785582, 0.658824, 0.980392, 0.843137, 0.7361646941267158, 0.764706, 0.980392, 0.866667, 0.7596088293041297, 0.827451, 0.980392, 0.886275, 0.7838273670706534, 0.913725, 0.988235, 0.937255, 0.7853981633974483, 1.0, 1.0, 1.0, 0.7869689597242432, 0.988235, 0.980392, 0.870588, 0.8111874974907669, 0.992157, 0.964706, 0.713725, 0.8322880045486029, 0.988235, 0.956863, 0.643137, 0.8729260763191136, 0.980392, 0.917647, 0.509804, 0.9127818915188803, 0.968627, 0.87451, 0.407843, 0.9495118220283256, 0.94902, 0.823529, 0.321569, 0.9817477042468103, 0.929412, 0.776471, 0.278431, 1.0210176124166828, 0.909804, 0.717647, 0.235294, 1.0602875205865552, 0.890196, 0.658824, 0.196078, 1.0995574287564276, 0.878431, 0.619608, 0.168627, 1.1388273369263, 0.870588, 0.54902, 0.156863, 1.1780972450961724, 0.85098, 0.47451, 0.145098, 1.2173671532660448, 0.831373, 0.411765, 0.133333, 1.2566370614359172, 0.811765, 0.345098, 0.113725, 1.2959069696057897, 0.788235, 0.266667, 0.0941176, 1.335176877775662, 0.741176, 0.184314, 0.0745098, 1.3744467859455345, 0.690196, 0.12549, 0.0627451, 1.413716694115407, 0.619608, 0.0627451, 0.0431373, 1.4571852684020996, 0.4, 0.00392157, 0.101961, 1.5707963267948966, 0.6784313725490196, 0.0, 0.03137254901960784]

# invert the transfer function
anglesLUT.InvertTransferFunction()

# invert the transfer function
anglesLUT.InvertTransferFunction()

# Properties modified on anglesPWF
anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 0.0882352963089943, 0.5, 0.0]

# Properties modified on anglesPWF
anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 0.08088235557079315, 0.5, 0.0]

# Properties modified on anglesPWF
anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 0.0882352963089943, 0.5, 0.0]

# Properties modified on anglesPWF
anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 0.09558823704719543, 0.5, 0.0]

# Properties modified on anglesPWF
anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 0.10294117778539658, 0.5, 0.0]

# Properties modified on anglesPWF
anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 0.11764705926179886, 0.5, 0.0]

# Properties modified on anglesPWF
anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 0.15441176295280457, 0.5, 0.0]

# Properties modified on anglesPWF
anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 0.13235294818878174, 0.5, 0.0]

# Properties modified on anglesLUT
anglesLUT.RGBPoints = [0.0, 0.12549, 0.0, 0.380392, 0.03926990816987245, 0.113725, 0.0235294, 0.45098, 0.0785398163397449, 0.105882, 0.0509804, 0.509804, 0.11780972450961717, 0.0392157, 0.0392157, 0.560784, 0.15707963267948963, 0.0313725, 0.0980392, 0.6, 0.19634954084936207, 0.0431373, 0.164706, 0.639216, 0.2356194490192345, 0.054902, 0.243137, 0.678431, 0.27488935718910695, 0.054902, 0.317647, 0.709804, 0.31415926535897926, 0.0509804, 0.396078, 0.741176, 0.35342917352885167, 0.0392157, 0.466667, 0.768627, 0.39269908169872414, 0.0313725, 0.537255, 0.788235, 0.450920647551377, 0.0313725, 0.615686, 0.811765, 0.5001541168221094, 0.0235294, 0.709804, 0.831373, 0.5470439579732639, 0.0509804, 0.8, 0.85098, 0.581428689566804, 0.0705882, 0.854902, 0.870588, 0.618940876646993, 0.262745, 0.901961, 0.862745, 0.6478560954306335, 0.423529, 0.941176, 0.87451, 0.6845860259400787, 0.572549, 0.964706, 0.835294, 0.7119383023785582, 0.658824, 0.980392, 0.843137, 0.7361646941267158, 0.764706, 0.980392, 0.866667, 0.7596088293041297, 0.827451, 0.980392, 0.886275, 0.7838273670706534, 0.913725, 0.988235, 0.937255, 0.7853981633974483, 1.0, 1.0, 1.0, 0.7869689597242432, 0.988235, 0.980392, 0.870588, 0.8111874974907669, 0.992157, 0.964706, 0.713725, 0.8322880045486029, 0.988235, 0.956863, 0.643137, 0.8729260763191136, 0.980392, 0.917647, 0.509804, 0.9127818915188803, 0.968627, 0.87451, 0.407843, 0.9495118220283256, 0.94902, 0.823529, 0.321569, 0.9817477042468103, 0.929412, 0.776471, 0.278431, 1.0210176124166828, 0.909804, 0.717647, 0.235294, 1.0602875205865552, 0.890196, 0.658824, 0.196078, 1.0995574287564276, 0.878431, 0.619608, 0.168627, 1.1388273369263, 0.870588, 0.54902, 0.156863, 1.1780972450961724, 0.85098, 0.47451, 0.145098, 1.2173671532660448, 0.831373, 0.411765, 0.133333, 1.2566370614359172, 0.811765, 0.345098, 0.113725, 1.2959069696057897, 0.788235, 0.266667, 0.0941176, 1.335176877775662, 0.741176, 0.184314, 0.0745098, 1.3744467859455345, 0.690196, 0.12549, 0.0627451, 1.413716694115407, 0.619608, 0.0627451, 0.0431373, 1.4571852684020996, 0.4, 0.00392157, 0.101961, 1.5707963267948966, 0.8313725490196079, 0.0, 0.0392156862745098]

# Properties modified on anglesPWF
anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 0.09558823704719543, 0.5, 0.0]

# Properties modified on anglesPWF
anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 0.125, 0.5, 0.0]

# Properties modified on anglesPWF
anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 0.09558823704719543, 0.5, 0.0]

# Properties modified on anglesPWF
anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 0.0882352963089943, 0.5, 0.0]

# Properties modified on anglesPWF
anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 0.08088235557079315, 0.5, 0.0]

# Properties modified on anglesPWF
anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 0.05882352963089943, 0.5, 0.0]

# Properties modified on anglesPWF
anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 0.08088235557079315, 0.5, 0.0]

# Properties modified on anglesPWF
anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 0.0882352963089943, 0.5, 0.0]

# Properties modified on anglesPWF
anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 0.09558823704719543, 0.5, 0.0]

# Properties modified on anglesPWF
anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 0.10294117778539658, 0.5, 0.0]


if hide_redcolor:
    # get color transfer function/color map for 'angles'
    anglesLUT = GetColorTransferFunction('angles')
    anglesLUT.EnableOpacityMapping = 1
    anglesLUT.RGBPoints = [0.0, 0.12549, 0.0, 0.380392, 0.03926990816987245, 0.113725, 0.0235294, 0.45098, 0.0785398163397449, 0.105882, 0.0509804, 0.509804, 0.11780972450961717, 0.0392157, 0.0392157, 0.560784, 0.15707963267948963, 0.0313725, 0.0980392, 0.6, 0.19634954084936207, 0.0431373, 0.164706, 0.639216, 0.2356194490192345, 0.054902, 0.243137, 0.678431, 0.27488935718910695, 0.054902, 0.317647, 0.709804, 0.31415926535897926, 0.0509804, 0.396078, 0.741176, 0.35342917352885167, 0.0392157, 0.466667, 0.768627, 0.39269908169872414, 0.0313725, 0.537255, 0.788235, 0.450920647551377, 0.0313725, 0.615686, 0.811765, 0.5001541168221094, 0.0235294, 0.709804, 0.831373, 0.5470439579732639, 0.0509804, 0.8, 0.85098, 0.581428689566804, 0.0705882, 0.854902, 0.870588, 0.618940876646993, 0.262745, 0.901961, 0.862745, 0.6478560954306335, 0.423529, 0.941176, 0.87451, 0.6845860259400787, 0.572549, 0.964706, 0.835294, 0.7119383023785582, 0.658824, 0.980392, 0.843137, 0.7361646941267158, 0.764706, 0.980392, 0.866667, 0.7596088293041297, 0.827451, 0.980392, 0.886275, 0.7838273670706534, 0.913725, 0.988235, 0.937255, 0.7853981633974483, 1.0, 1.0, 1.0, 0.7869689597242432, 0.988235, 0.980392, 0.870588, 0.8111874974907669, 0.992157, 0.964706, 0.713725, 0.8322880045486029, 0.988235, 0.956863, 0.643137, 0.8729260763191136, 0.980392, 0.917647, 0.509804, 0.9127818915188803, 0.968627, 0.87451, 0.407843, 0.9495118220283256, 0.94902, 0.823529, 0.321569, 0.9817477042468103, 0.929412, 0.776471, 0.278431, 1.0210176124166828, 0.909804, 0.717647, 0.235294, 1.0602875205865552, 0.890196, 0.658824, 0.196078, 1.0995574287564276, 0.878431, 0.619608, 0.168627, 1.1388273369263, 0.870588, 0.54902, 0.156863, 1.1780972450961724, 0.85098, 0.47451, 0.145098, 1.2173671532660448, 0.831373, 0.411765, 0.133333, 1.2566370614359172, 0.811765, 0.345098, 0.113725, 1.2959069696057897, 0.788235, 0.266667, 0.0941176, 1.335176877775662, 0.741176, 0.184314, 0.0745098, 1.3744467859455345, 0.690196, 0.12549, 0.0627451, 1.413716694115407, 0.619608, 0.0627451, 0.0431373, 1.4571852684020996, 0.4, 0.00392157, 0.101961, 1.5707963267948966, 0.8313725490196079, 0.0, 0.0392156862745098]
    anglesLUT.ColorSpace = 'Lab'
    anglesLUT.NanColor = [0.250004, 0.0, 0.0]
    anglesLUT.ScalarRangeInitialized = 1.0
    anglesLUT.Annotations = ['1.57', '$\\pi / 2$', '0.78', '$\\pi/4$', '0', '0']
    anglesLUT.IndexedColors = [1.0, 1.0, 1.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0]
    anglesLUT.IndexedOpacities = [1.0, 1.0, 1.0]

    # Apply a preset using its name. Note this may not work as expected when presets have duplicate names.
    anglesLUT.ApplyPreset('Preset', True)

    # get opacity transfer function/opacity map for 'angles'
    anglesPWF = GetOpacityTransferFunction('angles')
    anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.705621357414266, 1.0, 0.5, 0.0, 0.82168139570297, 1.0, 0.5, 0.0, 0.9799451305746117, 1.0, 0.5, 0.0, 1.0960051688633157, 1.0, 0.5, 0.0, 1.5707963267948966, 0.10294117778539658, 0.5, 0.0]
    anglesPWF.ScalarRangeInitialized = 1

    # Apply a preset using its name. Note this may not work as expected when presets have duplicate names.
    anglesPWF.ApplyPreset('Preset', True)

    # Properties modified on anglesPWF
    anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.4445649345539659, 1.0, 0.5, 0.0, 0.7310624366906182, 1.0, 0.5, 0.0, 0.9879222016222671, 1.0, 0.5, 0.0, 1.254661087453241, 0.9926470518112183, 0.5, 0.0, 1.5707963267948966, 0.07352941483259201, 0.5, 0.0]

    # Properties modified on anglesLUT
    anglesLUT.RGBPoints = [0.0, 0.0, 0.0, 1.0, 0.0, 0.17254901960784313, 0.043137254901960784, 0.9215686274509803, 0.0, 0.785929, 0.247056, 0.295477, 0.0, 0.17254901960784313, 0.043137254901960784, 0.9215686274509803, 0.266739073084488, 0.41568627450980394, 0.00392156862745098, 0.9686274509803922, 0.4198669450521392, 0.48627450980392156, 0.0, 0.9725490196078431, 0.7755188552446091, 1.0, 0.058823529411764705, 0.984313725490196, 1.2052651084495876, 1.0, 0.0196078431372549, 0.14901960784313725, 1.5707963267948966, 1.0, 0.0, 0.01568627450980392]

    # Properties modified on anglesLUT
    anglesLUT.RGBPoints = [0.0, 0.0, 0.0, 1.0, 0.0, 0.17254901960784313, 0.043137254901960784, 0.9215686274509803, 0.0, 0.785929, 0.247056, 0.295477, 0.0, 0.17254901960784313, 0.043137254901960784, 0.9215686274509803, 0.266739073084488, 0.41568627450980394, 0.00392156862745098, 0.9686274509803922, 0.4198669450521392, 0.48627450980392156, 0.0, 0.9725490196078431, 0.7755188552446091, 1.0, 0.058823529411764705, 0.984313725490196, 0.9888578653335571, 1.0, 0.996078431372549, 0.9921568627450981, 1.2052651084495876, 1.0, 0.0196078431372549, 0.14901960784313725, 1.5707963267948966, 1.0, 0.0, 0.01568627450980392]

    # Properties modified on anglesLUT
    anglesLUT.RGBPoints = [0.0, 0.0, 0.0, 1.0, 0.0, 0.17254901960784313, 0.043137254901960784, 0.9215686274509803, 0.0, 0.785929, 0.247056, 0.295477, 0.0, 0.17254901960784313, 0.043137254901960784, 0.9215686274509803, 0.266739073084488, 0.41568627450980394, 0.00392156862745098, 0.9686274509803922, 0.4198669450521392, 0.48627450980392156, 0.0, 0.9725490196078431, 0.7755188552446091, 1.0, 0.058823529411764705, 0.984313725490196, 0.9888578653335571, 1.0, 0.0392156862745098, 0.47058823529411764, 1.2052651084495876, 1.0, 0.0196078431372549, 0.14901960784313725, 1.5707963267948966, 1.0, 0.0, 0.01568627450980392]

    # Properties modified on anglesLUT
    anglesLUT.RGBPoints = [0.0, 0.0, 0.0, 1.0, 0.0, 0.17254901960784313, 0.043137254901960784, 0.9215686274509803, 0.0, 0.785929, 0.247056, 0.295477, 0.0, 0.17254901960784313, 0.043137254901960784, 0.9215686274509803, 0.266739073084488, 0.41568627450980394, 0.00392156862745098, 0.9686274509803922, 0.4198669450521392, 0.48627450980392156, 0.0, 0.9725490196078431, 0.7755188552446091, 1.0, 0.058823529411764705, 0.984313725490196, 1.0413635969161987, 1.0, 0.0392156862745098, 0.47058823529411764, 1.2052651084495876, 1.0, 0.0196078431372549, 0.14901960784313725, 1.5707963267948966, 1.0, 0.0, 0.01568627450980392]




    ###
    # get color transfer function/color map for 'angles'
    anglesLUT = GetColorTransferFunction('angles')
    anglesLUT.EnableOpacityMapping = 1
    anglesLUT.RGBPoints = [0.0, 0.0, 0.0, 1.0, 0.0, 0.17254901960784313, 0.043137254901960784, 0.9215686274509803, 0.0, 0.785929, 0.247056, 0.295477, 0.0, 0.17254901960784313, 0.043137254901960784, 0.9215686274509803, 0.266739073084488, 0.41568627450980394, 0.00392156862745098, 0.9686274509803922, 0.4198669450521392, 0.48627450980392156, 0.0, 0.9725490196078431, 0.7755188552446091, 1.0, 0.058823529411764705, 0.984313725490196, 1.0413635969161987, 1.0, 0.0392156862745098, 0.47058823529411764, 1.2052651084495876, 1.0, 0.0196078431372549, 0.14901960784313725, 1.5707963267948966, 1.0, 0.0, 0.01568627450980392]
    anglesLUT.NanColor = [0.250004, 0.0, 0.0]
    anglesLUT.ScalarRangeInitialized = 1.0
    anglesLUT.Annotations = ['1.57', '$\\pi / 2$', '0.78', '$\\pi/4$', '0', '0']
    anglesLUT.IndexedColors = [1.0, 1.0, 1.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0]
    anglesLUT.IndexedOpacities = [1.0, 1.0, 1.0]

    # get opacity transfer function/opacity map for 'angles'
    anglesPWF = GetOpacityTransferFunction('angles')
    anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.4445649345539659, 1.0, 0.5, 0.0, 0.7310624366906182, 1.0, 0.5, 0.0, 0.9879222016222671, 1.0, 0.5, 0.0, 1.254661087453241, 0.9926470518112183, 0.5, 0.0, 1.5707963267948966, 0.07352941483259201, 0.5, 0.0]
    anglesPWF.ScalarRangeInitialized = 1

    # Properties modified on anglesPWF
    anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.4445649345539659, 1.0, 0.5, 0.0, 0.7310624366906182, 1.0, 0.5, 0.0, 0.9879222016222671, 1.0, 0.5, 0.0, 1.254661087453241, 0.9926470518112183, 0.5, 0.0, 1.5707963267948966, 0.036764707416296005, 0.5, 0.0]

    # # Properties modified on anglesPWF
    # anglesPWF.Points = [0.0, 1.0, 0.5, 0.0, 0.4445649345539659, 1.0, 0.5, 0.0, 0.7310624366906182, 1.0, 0.5, 0.0, 0.9879222016222671, 1.0, 0.5, 0.0, 1.254661087453241, 0.9926470518112183, 0.5, 0.0, 1.5707963267948966, 0.03, 0.5, 0.0]

    #### uncomment the following to render all views
    #### uncomment the following to render all views




# update the view to ensure updated data information
renderView1.Update()


# ----------------- EXPORT -----------------
# save screenshot
# SaveScreenshot('/home/klaus/Desktop/PhaseDiagramPlot.png', renderView1, ImageResolution=[1257, 934])
# SaveScreenshot('/home/klaus/Desktop/PhaseDiagramPlot.png', renderView1, ImageResolution=[2514, 1868])
# SaveScreenshot('/home/klaus/Desktop/PhaseDiagramPlot.png', renderView1, ImageResolution=[1063, 657])

if gamma == '0' :
    # SaveScreenshot('/home/klaus/Desktop/3DPhaseDiagramPlot_Gamma0.png', renderView1, ImageResolution=[2126, 1314])
    SaveScreenshot('/home/klaus/Desktop/3DPhaseDiagramPlot_Gamma0.png', renderView1, ImageResolution=[2126, 1314],OverrideColorPalette='WhiteBackground')

elif gamma == 'infinity':
    # SaveScreenshot('/home/klaus/Desktop/3DPhaseDiagramPlot_GammaInf.png', renderView1, ImageResolution=[2126, 1314])
    SaveScreenshot('/home/klaus/Desktop/3DPhaseDiagramPlot_GammaInf.png', renderView1, ImageResolution=[2126, 1314],OverrideColorPalette='WhiteBackground')
# export view
# ExportView('/home/klaus/Desktop/PhaseDiagramPlot.pdf', view=renderView1)
